<?php

namespace App\Security\Voter;

use App\Entity\Party;
use Symfony\Component\Security\Core\Authentication\Token\TokenInterface;
use Symfony\Component\Security\Core\Authorization\Voter\Voter;
use Symfony\Component\Security\Core\User\UserInterface;

class PartyAccessVoter extends Voter
{
    public const ACCESS_PARTY = 'ACCESS_PARTY';

    protected function supports(string $attribute, $subject): bool
    {
        return $attribute === self::ACCESS_PARTY && $subject instanceof Party;
    }

    protected function voteOnAttribute(string $attribute, $subject, TokenInterface $token): bool
    {
        $user = $token->getUser();

        if (!$user instanceof UserInterface) {
            return false;
        }

        $roles = $user->getRoles();

        // Accès immédiat pour ADMIN ou MANAGER
        if (in_array('ROLE_ADMIN', $roles, true) || in_array('ROLE_MANAGER', $roles, true)) {
            return true;
        }

        // Vérifie les droits pour ROLE_STAFF
        if (in_array('ROLE_STAFF', $roles, true)) {
            $gamemaster = $user->getLinkToGamemaster();

            if (!$gamemaster) {
                return false;
            }
            // Accès si c'est le MJ de la partie
            return ($subject->getGamemaster() == $gamemaster);
        }

        // ❌ Aucun autre rôle n'est autorisé
        return false;
    }
}